Merge pull request #717 from mono/client_websockets_impl
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve gc-descriptors
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17
18 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
19
20 MKBUNDLE = \
21         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
22         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
23
24 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
25 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
26
27 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
28
29 STRESS_TESTS_SRC=       \
30         abort-stress-1.cs       \
31         abort-stress-2.cs       \
32         abort-stress-3.cs       \
33         domain-stress.cs        \
34         gchandle-stress.cs      \
35         monitor-stress.cs       \
36         thread-stress.cs        \
37         gc-stress.cs            \
38         exit-stress.cs          \
39         process-stress.cs       \
40         assembly-load-stress.cs
41
42 # Disabled until ?mcs is fixed
43 #       bug-331958.cs
44 BASE_TEST_CS_SRC=               \
45         bug-2907.cs             \
46         array-init.cs           \
47         arraylist.cs            \
48         assemblyresolve_event.cs        \
49         assemblyresolve_event3.cs       \
50         checked.cs              \
51         char-isnumber.cs        \
52         create-instance.cs      \
53         field-layout.cs         \
54         pack-layout.cs          \
55         pack-bug.cs             \
56         hash-table.cs           \
57         test-ops.cs             \
58         obj.cs                  \
59         test-dup-mp.cs          \
60         string.cs               \
61         stringbuilder.cs        \
62         switch.cs               \
63         outparm.cs              \
64         delegate.cs             \
65         bitconverter.cs         \
66         exception.cs            \
67         exception2.cs           \
68         exception3.cs           \
69         exception4.cs           \
70         exception5.cs           \
71         exception6.cs           \
72         exception7.cs           \
73         exception8.cs           \
74         exception10.cs          \
75         exception11.cs          \
76         exception12.cs          \
77         exception13.cs          \
78         exception14.cs          \
79         exception15.cs          \
80         exception16.cs          \
81         exception17.cs          \
82         typeload-unaligned.cs   \
83         struct.cs               \
84         valuetype-gettype.cs    \
85         typeof-ptr.cs           \
86         static-constructor.cs   \
87         pinvoke.cs              \
88         pinvoke2.cs             \
89         pinvoke3.cs             \
90         pinvoke11.cs            \
91         pinvoke13.cs            \
92         pinvoke17.cs            \
93         invoke.cs               \
94         invoke2.cs              \
95         runtime-invoke.cs               \
96         invoke-string-ctors.cs          \
97         reinit.cs               \
98         box.cs                  \
99         array.cs                \
100         enum.cs                 \
101         enum2.cs                \
102         property.cs             \
103         enumcast.cs             \
104         assignable-tests.cs     \
105         array-cast.cs           \
106         array-subtype-attr.cs   \
107         cattr-compile.cs        \
108         cattr-field.cs          \
109         cattr-object.cs         \
110         custom-attr.cs          \
111         double-cast.cs          \
112         newobj-valuetype.cs     \
113         arraylist-clone.cs      \
114         setenv.cs               \
115         vtype.cs                \
116         isvaluetype.cs          \
117         iface6.cs               \
118         iface7.cs               \
119         ipaddress.cs            \
120         array-vt.cs             \
121         interface1.cs           \
122         reflection-enum.cs      \
123         reflection-prop.cs      \
124         reflection4.cs          \
125         reflection5.cs          \
126         reflection-const-field.cs \
127         many-locals.cs          \
128         string-compare.cs       \
129         test-prime.cs           \
130         params.cs               \
131         reflection.cs           \
132         interface.cs            \
133         iface.cs                \
134         iface2.cs               \
135         iface3.cs               \
136         iface4.cs               \
137         iface-large.cs          \
138         virtual-method.cs       \
139         intptrcast.cs           \
140         indexer.cs              \
141         stream.cs               \
142         console.cs              \
143         shift.cs                \
144         jit-int.cs              \
145         jit-uint.cs             \
146         jit-long.cs             \
147         long.cs                 \
148         jit-ulong.cs            \
149         jit-float.cs            \
150         pop.cs                  \
151         time.cs                 \
152         appdomain.cs        \
153         appdomain1.cs           \
154         appdomain2.cs           \
155         appdomain-client.cs     \
156         appdomain-unload.cs \
157         appdomain-async-invoke.cs       \
158         loader.cs       \
159         pointer.cs              \
160         hashcode.cs             \
161         delegate1.cs            \
162         delegate2.cs            \
163         delegate3.cs            \
164         delegate5.cs            \
165         delegate6.cs            \
166         delegate7.cs            \
167         delegate8.cs            \
168         delegate9.cs            \
169         remoting1.cs            \
170         remoting2.cs            \
171         remoting3.cs            \
172         remoting4.cs            \
173         remoting5.cs            \
174         largeexp.cs             \
175         largeexp2.cs            \
176         marshalbyref1.cs        \
177         static-ctor.cs          \
178         inctest.cs              \
179         bound.cs                \
180         array-invoke.cs         \
181         test-arr.cs             \
182         decimal.cs              \
183         decimal-array.cs        \
184         marshal.cs              \
185         marshal1.cs             \
186         marshal2.cs             \
187         marshal3.cs             \
188         marshal5.cs             \
189         marshal6.cs             \
190         marshal7.cs             \
191         marshal8.cs             \
192         marshal9.cs             \
193         marshalbool.cs          \
194         marshal-valuetypes.cs   \
195         test-byval-in-struct.cs \
196         thread.cs               \
197         thread5.cs              \
198         thread6.cs              \
199         thread-static.cs        \
200         thread-static-init.cs   \
201         context-static.cs       \
202         float-pop.cs            \
203         interfacecast.cs        \
204         array3.cs               \
205         classinit.cs            \
206         classinit2.cs           \
207         synchronized.cs         \
208         async_read.cs           \
209         threadpool.cs           \
210         threadpool1.cs          \
211         threadpool-exceptions1.cs \
212         threadpool-exceptions2.cs \
213         threadpool-exceptions3.cs \
214         threadpool-exceptions4.cs \
215         threadpool-exceptions5.cs \
216         threadpool-exceptions6.cs \
217         threadpool-exceptions7.cs \
218         base-definition.cs      \
219         bug-27420.cs            \
220         bug-47295.cs            \
221         bug-46781.cs            \
222         bug-48015.cs            \
223         bug-42136.cs            \
224         bug-59286.cs            \
225         bug-70561.cs            \
226         bug-78311.cs            \
227         bug-78653.cs            \
228         bug-78656.cs            \
229         bug-77127.cs            \
230         bug-323114.cs           \
231         bug-Xamarin-5278.cs     \
232         interlocked.cs          \
233         cross-domain.cs         \
234         appdomain-exit.cs       \
235         delegate-async-exit.cs  \
236         delegate-delegate-exit.cs       \
237         delegate-exit.cs        \
238         finalizer-abort.cs      \
239         finalizer-exception.cs  \
240         finalizer-exit.cs       \
241         finalizer-thread.cs     \
242         main-exit.cs    \
243         main-returns-abort-resetabort.cs        \
244         main-returns-background-abort-resetabort.cs     \
245         main-returns-background-resetabort.cs   \
246         main-returns-background.cs      \
247         main-returns-background-change.cs       \
248         main-returns.cs         \
249         subthread-exit.cs       \
250         desweak.cs              \
251         cominterop.cs           \
252         exists.cs               \
253         handleref.cs    \
254         transparentproxy.cs \
255         dbnull-missing.cs       \
256         test-type-ctor.cs       \
257         soft-float-tests.cs     \
258         thread-exit.cs          \
259         finalize-parent.cs      \
260         assemblyresolve_event2.2.cs     \
261         interlocked-2.2.cs      \
262         pinvoke-2.2.cs          \
263         bug-78431.2.cs          \
264         bug-79684.2.cs          \
265         catch-generics.2.cs     \
266         event-get.2.cs          \
267         safehandle.2.cs         \
268         stackframes-async.2.cs          \
269         module-cctor-loader.2.cs        \
270         generics-invoke-byref.2.cs      \
271         generic-signature-compare.2.cs  \
272         generics-sharing.2.cs   \
273         shared-generic-methods.2.cs     \
274         shared-generic-synchronized.2.cs        \
275         generic-inlining.2.cs   \
276         generic-initobj.2.cs    \
277         generic-delegate.2.cs   \
278         generic-sizeof.2.cs     \
279         generic-virtual.2.cs    \
280         generic-interface-methods.2.cs  \
281         generic-array-type.2.cs \
282         generic-method-patching.2.cs    \
283         generic-static-methods.2.cs     \
284         generic-null-call.2.cs  \
285         generic-special.2.cs    \
286         generic-exceptions.2.cs \
287         generic-virtual2.2.cs   \
288         generic-valuetype-interface.2.cs        \
289         generic-getgenericarguments.2.cs        \
290         generic-type-builder.2.cs       \
291         generic-synchronized.2.cs       \
292         generic-delegate-ctor.2.cs      \
293         generic-array-iface-set.2.cs    \
294         generic-typedef.2.cs    \
295         generic-marshalbyref.2.cs       \
296         generic-xdomain.2.cs    \
297         bug-431413.2.cs \
298         bug-459285.2.cs \
299         generic-virtual-invoke.2.cs     \
300         bug-461198.2.cs \
301         generic-sealed-virtual.2.cs     \
302         generic-system-arrays.2.cs      \
303         generic-stack-traces.2.cs       \
304         generic-stack-traces2.2.cs      \
305         bug-472600.2.cs \
306         recursive-generics.2.cs \
307         bug-473482.2.cs \
308         bug-473999.2.cs \
309         bug-479763.2.cs \
310         bug-616463.cs   \
311         bug-80392.2.cs          \
312         dynamic-method-access.2.cs      \
313         dynamic-method-finalize.2.cs    \
314         bug-82194.2.cs  \
315         anonarray.2.cs  \
316         ienumerator-interfaces.2.cs     \
317         array-enumerator-ifaces.2.cs    \
318         generic_type_definition_encoding.2.cs \
319         generic_type_definition.2.cs    \
320         bug-333798.2.cs         \
321         bug-333798-tb.2.cs              \
322         bug-335131.2.cs         \
323         bug-322722_patch_bx.2.cs                \
324         bug-348522.2.cs         \
325         bug-340662_bug.cs       \
326         bug-322722_dyn_method_throw.2.cs        \
327         bug-389886-2.cs \
328         bug-325283.2.cs \
329         thunks.cs \
330         winx64structs.cs \
331         bug-349190.2.cs \
332         nullable_boxing.2.cs    \
333         valuetype-equals.cs     \
334         custom-modifiers.2.cs   \
335         bug-382986.cs   \
336         test-inline-call-stack.cs       \
337         bug-324535.cs   \
338         modules.cs      \
339         bug-81673.cs    \
340         bug-81691.cs    \
341         bug-80307.cs    \
342         bug-415577.cs   \
343         filter-stack.cs \
344         vararg2.cs      \
345         bug-389886-sre-generic-interface-instances.cs   \
346         bug-461867.cs   \
347         bug-461941.cs   \
348         bug-461261.cs   \
349         bug-400716.cs   \
350         bug-462592.cs   \
351         bug-459094.cs   \
352         generic-unloading.2.cs  \
353         generic-unloading-sub.2.cs      \
354         bug-467456.cs   \
355         appdomain-unload-callback.cs    \
356         bug-508538.cs   \
357         bug-472692.2.cs         \
358         gchandles.cs    \
359         interlocked-3.cs        \
360         interlocked-4.2.cs      \
361         appdomain-thread-abort.cs \
362         xdomain-threads.cs      \
363         w32message.cs   \
364         bug-544446.cs   \
365         gc-altstack.cs  \
366         large-gc-bitmap.cs      \
367         bug-561239.cs   \
368         bug-562150.cs   \
369         bug-575941.cs   \
370         bug-599469.cs   \
371         bug-389886-3.cs \
372         monitor.cs      \
373         dynamic-method-resurrection.cs  \
374         bug-666008.cs   \
375         bug-685908.cs   \
376         sgen-long-vtype.cs      \
377         delegate-invoke.cs      \
378         bug-696593.cs   \
379         bug-705140.cs   \
380         bug-1147.cs     \
381         mono-path.cs    \
382         bug-bxc-795.cs  \
383         bug-3903.cs     \
384         async-with-cb-throws.cs \
385         appdomain-unload-doesnot-raise-pending-events.cs        \
386         bug-6148.cs     \
387         assembly_append_ordering.cs     \
388         bug-10127.cs    \
389         allow-synchronous-major.cs      \
390         unload-appdomain-on-shutdown.cs \
391         block_guard_restore_aligment_on_exit.cs \
392         finally_block_ending_in_dead_bb.cs
393
394 TEST_CS_SRC_DIST=       \
395         $(BASE_TEST_CS_SRC)     \
396         async-exc-compilation.cs \
397         filter-stack.cs \
398         finally_guard.cs
399
400 TEST_CS_SRC_GEN = \
401         runtime-invoke.gen.cs \
402         imt_big_iface_test.cs
403
404 if AMD64
405 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
406 # #651684
407 PLATFORM_DISABLED_TESTS = finally_guard.exe
408 else
409 if X86
410 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
411 else
412 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
413 endif
414 endif
415
416 if IA64
417 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
418 # bug #319249
419 PLATFORM_DISABLED_TESTS=exception17.exe
420 PLATFORM_DISABLED_TESTS+=winx64structs.exe
421 endif
422
423 if X86
424
425 if HOST_WIN32
426 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
427 endif
428
429 endif
430
431 if POWERPC
432 # bug #71274
433 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
434 endif
435
436 if ARM
437 PLATFORM_DISABLED_TESTS=filter-stack.exe
438 endif
439
440 if MIPS
441 # monitor.exe is racy
442 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
443 endif
444
445 if S390X
446 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
447 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
448 endif
449
450 if NACL_CODEGEN
451 # Tests that use Thread.Abort()
452 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
453                          abort-stress-2.exe \
454                          abort-stress-3.exe \
455                          appdomain-thread-abort.exe \
456                          async-exc-compilation.exe \
457                          bug-561239.exe \
458                          bug-70561.exe \
459                          finalizer-abort.exe \
460                          finally_guard.exe \
461                          main-returns-abort-resetabort.exe \
462                          main-returns-background-abort-resetabort.exe \
463                          thread6.exe \
464                          threadpool-exceptions5.exe \
465                          threadpool-exceptions6.exe
466
467 # Tests that rely on AppDomain.Unload
468 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
469                           appdomain-exit.exe \
470                           appdomain-unload-callback.exe \
471                           appdomain-unload.exe \
472                           domain-stress.exe \
473                           generic-unloading.2.exe \
474                           monitor.exe \
475                           remoting4.exe \
476                           threadpool-exceptions7.exe \
477                           xdomain-threads.exe
478
479 # pinvoke2 attaches a thread to the runtime, but
480 # doesn't 'unattach' it and it hangs in GC on exit
481 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
482
483 # Tests that currently hang waiting for non-main threads
484 # to exit in NaCl, need to investigate.  Most are AppDomain
485 # creation and Delegate tests.
486 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
487                           delegate9.exe \
488                           marshal-valuetypes.exe \
489                           cross-domain.exe \
490                           stackframes-async.2.exe \
491                           generic-marshalbyref.2.exe \
492                           generic-xdomain.2.exe \
493                           bug-415577.exe
494
495 # Tests that fail trying to write files (appdomain create mostly)
496 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
497                           bug-349190.2.exe \
498                           bug-80307.exe \
499                           bug-462592.exe
500
501 # FIXME: don't know why delegate2.exe fails, it shouldn't
502 PLATFORM_DISABLED_TESTS+= delegate2.exe
503
504 # These tests newly fail with the latest revision. pinvoke3 fails because
505 # of a thread attach, the others have not been investigated.  TODO revisit.
506 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
507                           async_read.exe \
508                           async-with-cb-throws.exe \
509                           appdomain-unload-doesnot-raise-pending-events.exe \
510                           gsharing-valuetype-layout.exe
511
512 if X86
513 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
514 PLATFORM_DISABLED_TESTS+= delegate1.exe \
515                           delegate3.exe \
516                           delegate5.exe \
517                           delegate8.exe \
518                           threadpool.exe \
519                           threadpool1.exe \
520                           threadpool-exceptions3.exe \
521                           bug-323114.exe \
522                           delegate-exit.exe \
523                           bug-80392.2.exe
524
525 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
526 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
527                           main-returns-background.exe \
528                           main-returns-background-change.exe
529 endif
530
531 endif
532
533 # The two finalizer tests only work under sgen
534 # gc-altstack.exe fails under boehm because it has no support for altstack
535 # bug-459094.exe creates an extremely deep directory tree
536 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
537 # reverted.
538 DISABLED_TESTS=                 \
539         delegate-async-exception.exe    \
540         bug-348522.2.exe        \
541         bug-459094.exe \
542         delegate-invoke.exe \
543         $(PLATFORM_DISABLED_TESTS)
544
545 DISABLED_TESTS_WRENCH=  \
546         $(DISABLED_TESTS)       \
547         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
548         main-returns-background-resetabort.exe \
549         main-returns-background-abort-resetabort.exe    \
550         thread6.exe     \
551         assemblyresolve_event3.exe \
552         delegate2.exe   \
553         finally_guard.exe \
554         gc-altstack.exe
555
556 AOT_DISABLED_TESTS=constraints-load.exe
557
558 # These only compile with MS CSC
559 TEST_CSC_SRC=                   \
560         vararg.cs
561
562 TEST_IL_SRC=                    \
563         field-access.il         \
564         method-access.il        \
565         ldftn-access.il         \
566         cpblkTest.il            \
567         vbinterface.il          \
568         calliTest.il            \
569         ckfiniteTest.il         \
570         fault-handler.il                \
571         locallocTest.il         \
572         initblkTest.il          \
573         qt-instance.il          \
574         vararg.il               \
575         bug-29859.il            \
576         bug-78549.il            \
577         static-fields-nonconst.il       \
578         reload-at-bb-end.il     \
579         test-enum-indstoreil.il \
580         filter-bug.il           \
581         even-odd.il             \
582         bug-82022.il    \
583         vt-sync-method.il       \
584         enum_types.il   \
585         invalid-token.il        \
586         call_missing_method.il  \
587         call_missing_class.il   \
588         ldfld_missing_field.il  \
589         ldfld_missing_class.il  \
590         find-method.2.il        \
591         bug-79215.2.il  \
592         bug-79956.2.il  \
593         bug-327438.2.il \
594         bug-387274.2.il \
595         bug-426309.2.il \
596         ldtoken_with_byref_typespec.2.il \
597         resolve_method_bug.2.il \
598         resolve_field_bug.2.il \
599         resolve_type_bug.2.il   \
600         generics-sharing-other-exc.2.il \
601         generic-ldobj.2.il      \
602         generic-mkrefany.2.il   \
603         generic-refanyval.2.il  \
604         generic-ldtoken.2.il    \
605         generic-ldtoken-method.2.il     \
606         generic-ldtoken-field.2.il      \
607         generic-tailcall.2.il   \
608         generic-tailcall2.2.il  \
609         generic-array-exc.2.il  \
610         generic-valuetype-newobj2.2.il  \
611         generic-valuetype-newobj.2.il   \
612         generic-constrained.2.il        \
613         generic-type-load-exception.2.il        \
614         bug-81466.il    \
615         bug457574.il    \
616         bug445361.il    \
617         bug-463303.il   \
618         bug469742.2.il  \
619         bug-528055.il   \
620         constraints-load.il     \
621         array_load_exception.il \
622         bug-481403.il   \
623         interface-with-static-method.il \
624         bug-515884.il   \
625         bug-633291.il   \
626         delegate-with-null-target.il    \
627         bug-318677.il   \
628         gsharing-valuetype-layout.il    \
629         invalid_generic_instantiation.il
630
631
632 # pre-requisite test sources: files that are not test themselves
633 # but that need to be compiled
634 PREREQ_IL_SRC=event-il.il module-cctor.il
635 PREREQ_CS_SRC=
636 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
637 PREREQ_CS_DLL_SRC=
638
639 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
640 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
641 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
642 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
643 TESTBS=$(BENCHSRC:.cs=.exe)
644 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
645
646 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
647         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
648
649 %.exe: %.il
650         $(ILASM) -out:$@ $<
651
652 %.exe: %.cs TestDriver.dll
653         $(MCS) -r:TestDriver.dll -out:$@ $<
654
655 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
656 if POWERPC
657 test_platform:
658 else
659 # Can't use mkbundle on win32 since there is no static build there
660 # Can't run test-unhandled-exception on Windows because of all the debug popups...
661 if HOST_WIN32
662 test_platform:
663 else
664 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
665 #test_platform: testbundle test-iomap-regression
666 test_platform:  test-iomap-regression
667 endif
668 endif
669
670 if X86
671 if HOST_WIN32
672 else
673 test_platform: test-eglib-remap
674 endif
675 endif
676
677 # Target to precompile the test executables
678 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
679
680 #
681 # Test that no symbols are missed in eglib-remap.h
682 #
683 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
684 if NACL_CODEGEN
685 test-eglib-remap:
686 else
687 test-eglib-remap:
688         @echo "Testing eglib remap..."
689         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
690 endif
691
692 #
693 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
694 # code that checks that the table is properly sorted
695 #
696 if NACL_CODEGEN
697 test-messages:
698 else
699 test-messages: w32message.exe
700         > test_messages.zero
701         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
702 endif
703
704 if AMD64
705 test-sgen : sgen-tests
706 else
707 if X86
708 if HOST_WIN32
709 test-sgen :
710 else
711 test-sgen : sgen-tests
712 endif
713 else
714 if ARM
715 test-sgen : sgen-tests
716 else
717 if S390X
718 test-sgen : sgen-regular-tests
719 endif
720 endif
721 endif
722 endif
723
724 # Precompile the test assemblies in parallel
725 compile-tests:
726         $(MAKE) -j4 $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
727
728 test: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test_platform test-process-exit test-messages rm-empty-logs
729 test-wrench: compile-tests assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test-process-exit test-sgen test-messages rm-empty-logs
730
731 # Remove empty .stdout and .stderr files for wrench
732 rm-empty-logs:
733         @echo "Removing empty logs..."
734         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
735
736 assemblyresolve/test/asm.dll:
737         $(MAKE) -C assemblyresolve prereq
738
739 TestDriver.dll:
740         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
741
742 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
743         @failed=0; \
744         passed=0; \
745         for i in $(TESTSI_CS); do       \
746                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
747                 then \
748                         passed=`expr $${passed} + 1`; \
749                 else \
750                         if [ $$? = 2 ]; then break; fi; \
751                         failed=`expr $${failed} + 1`; \
752                 fi \
753         done; \
754         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
755
756 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
757         @failed=0; \
758         passed=0; \
759         for i in $(TESTSI_IL); do       \
760                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" 'no-dump' $(RUNTIME_ARGS); \
761                 then \
762                         passed=`expr $${passed} + 1`; \
763                 else \
764                         if [ $$? = 2 ]; then break; fi; \
765                         failed=`expr $${failed} + 1`; \
766                 fi \
767         done; \
768         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
769
770 testb: $(TEST_PROG) $(TESTBS)
771         for i in $(TESTBS); do  \
772                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS);   \
773         done
774
775 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
776         @failed=0; \
777         passed=0; \
778         failed_tests="";\
779         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
780                 rm -f $${i}.so; \
781                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
782                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' 'dump-output' $(RUNTIME_ARGS); \
783                 then \
784                         passed=`expr $${passed} + 1`; \
785                 else \
786                         if [ $$? = 2 ]; then break; fi; \
787                         failed=`expr $${failed} + 1`; \
788                         failed_tests="$${failed_tests} $$i"; \
789                 fi \
790         done; \
791         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
792         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
793           for i in $${failed_tests}; do echo $${i}; cat $${i}.stdout; cat $${i}.stderr; done; exit 1; fi
794
795 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
796         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
797
798 testjit-wrench:
799         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
800
801 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
802         @failed=0; \
803         passed=0; \
804         failed_tests="";\
805         rm -f testlist testlist.sorted; \
806         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do echo $${i} >> testlist; sort testlist > testlist.sorted; done; \
807         for i in `cat testlist.sorted`; do \
808                 rm -f $${i}.so; \
809                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
810                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
811                 then \
812                         passed=`expr $${passed} + 1`; \
813                 else \
814                         if [ $$? = 2 ]; then break; fi; \
815                         failed=`expr $${failed} + 1`; \
816                         failed_tests="$${failed_tests} $$i"; \
817                 fi \
818         done; \
819         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
820         rm -f testlist testlist.sorted; \
821         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
822           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
823
824 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
825         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
826
827 testjit:
828         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
829
830 testaot:
831         @$(MAKE) AOT=1 runtest
832
833 testtrace:
834         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
835
836 testinterp:
837         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
838
839 testjitspeed: $(JITTEST_PROG) $(TESTBS)
840         for i in $(TESTBS); do  \
841                 echo $$i;       \
842                 time $(JITTEST_PROG) $$i;       \
843         done
844
845 test-iomap-regression: exists.cs
846         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
847         @echo "Testing exists.exe..."
848         @MONO_IOMAP=all $(RUNTIME) exists.exe
849
850 stresstest: $(STRESS_TESTS)
851         @failed=0; \
852         passed=0; \
853         failed_tests="";\
854         for i in $(STRESS_TESTS); do    \
855                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
856                 then \
857                         passed=`expr $${passed} + 1`; \
858                 else \
859                         if [ $$? = 2 ]; then break; fi; \
860                         failed=`expr $${failed} + 1`; \
861                         failed_tests="$${failed_tests} $$i"; \
862                 fi \
863         done; \
864         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
865         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
866           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
867
868 testbundle: console.exe
869         @echo "Testing mkbundle..."
870         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
871         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
872         @- rm -rf a.out
873
874 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
875 test-type-load: TestDriver.dll
876         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
877         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
878         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
879         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
880         @echo "Testing load-exception.exe..."
881         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
882
883 EXTRA_DIST += debug-casts.cs
884 # This depends on TLS, so its not ran by default
885 debug-casts:
886         @$(MCS) -r:TestDriver.dll $(srcdir)/debug-casts.cs
887         @$(RUNTIME) --debug=casts debug-casts.exe
888
889 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs sgen-domain-unload-2.cs sgen-suspend.cs sgen-new-threads-dont-join-stw.cs sgen-bridge-xref.cs
890
891
892 #those are actually configurations, eg plain_sgen-descriptors.exe
893 #DISABLE_SGEN_TESTS =
894
895 SGEN_TESTS =    \
896         finalizer-wait.exe      \
897         critical-finalizers.exe \
898         sgen-descriptors.exe    \
899         sgen-gshared-vtype.exe  \
900         sgen-domain-unload.exe  \
901         sgen-weakref-stress.exe \
902         sgen-cementing-stress.exe       \
903         sgen-case-23400.exe     \
904         sgen-new-threads-dont-join-stw.exe
905
906 SGEN_CONFIGURATIONS =   \
907         "|plain"        \
908         "major=marksweep-par|ms-par"    \
909         "major=marksweep-conc|ms-conc"  \
910         "major=marksweep-conc,minor=split|ms-conc-split"        \
911         "minor=split|ms-split"  \
912         "minor=split,alloc-ratio=95|ms-split-95"
913
914 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
915 SGEN_BRIDGE_CONFIGURATIONS =    \
916         "|plain"        \
917         ",major=marksweep-conc|ms-conc" \
918         ",minor=split|ms-split"
919
920 sgen-regular-tests: $(SGEN_TESTS)
921         @failed=0; \
922         passed=0; \
923         failed_tests="";\
924         for test in $+; do      \
925                 echo "...$$test";       \
926                 for conf in $(SGEN_CONFIGURATIONS); do  \
927                         name=`echo $$conf | cut -d\| -f 2`;     \
928                         params=`echo $$conf | cut -d\| -f 1`;   \
929                         test_name="$${test}|$${name}";  \
930                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
931                         then \
932                                 passed=`expr $${passed} + 1`; \
933                         else \
934                                 if [ $$? = 2 ]; then break; fi; \
935                                 failed=`expr $${failed} + 1`; \
936                                 failed_tests="$${failed_tests} $$test_name"; \
937                         fi \
938                 done    \
939         done;   \
940         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
941         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
942           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
943
944 sgen-bridge-tests1: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
945         @failed=0; \
946         passed=0; \
947         failed_tests="";\
948         for test in $+; do      \
949                 echo "...$$test";       \
950                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
951                         name=`echo $$conf | cut -d\| -f 2`;     \
952                         params=`echo $$conf | cut -d\| -f 1`;   \
953                         test_name="$${test}|$${name}";  \
954                         if MONO_GC_PARAMS="bridge=Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);      \
955                         then \
956                                 passed=`expr $${passed} + 1`; \
957                         else \
958                                 if [ $$? = 2 ]; then break; fi; \
959                                 failed=`expr $${failed} + 1`; \
960                                 failed_tests="$${failed_tests} $$test_name"; \
961                         fi \
962                 done    \
963         done;   \
964         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
965         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
966           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
967
968 sgen-bridge-tests2: sgen-bridge-xref.exe
969         @failed=0; \
970         passed=0; \
971         failed_tests="";\
972         for test in $+; do      \
973                 echo "...$$test";       \
974                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
975                         name=`echo $$conf | cut -d\| -f 2`;     \
976                         params=`echo $$conf | cut -d\| -f 1`;   \
977                         test_name="$${test}|$${name}";  \
978                         if MONO_GC_PARAMS="bridge=2Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
979                         then \
980                                 passed=`expr $${passed} + 1`; \
981                         else \
982                                 if [ $$? = 2 ]; then break; fi; \
983                                 failed=`expr $${failed} + 1`; \
984                                 failed_tests="$${failed_tests} $$test_name"; \
985                         fi \
986                 done    \
987         done;   \
988         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
989         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
990           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
991
992
993 sgen-bridge-tests: sgen-bridge-tests1 sgen-bridge-tests2
994
995 sgen-tests: sgen-regular-tests sgen-bridge-tests
996
997 AOT_CONFIGURATIONS=     \
998         "|regular"      \
999         "--gc=boehm|boehm"
1000
1001 #LLVM crashes, got to fix it first.
1002 #       "--llvm|llvm"   \
1003 #       "--llvm --gc=boehm|llvm+boehm"
1004
1005
1006 test-aot:
1007         @failed=0; \
1008         passed=0; \
1009         failed_tests="";\
1010         profile=net_4_5;        \
1011         tmpfile=`mktemp -t mono_aot_output` || exit 1;  \
1012         rm -f test-aot-$${name}.stdout test-aot-$${name}.stderr; \
1013         for assembly in $(mcs_topdir)/class/lib/$$profile/*.dll ; do    \
1014                 asm_name=`basename $$assembly`; \
1015                 echo "... $$asm_name";  \
1016                 for conf in $(AOT_CONFIGURATIONS); do   \
1017                         name=`echo $$conf | cut -d\| -f 2`;     \
1018                         params=`echo $$conf | cut -d\| -f 1`;   \
1019                         test_name="$${asm_name}|$${name}";      \
1020                         echo "  $$test_name";   \
1021                         if MONO_PATH=$(mcs_topdir)/class/lib/$$profile $(JITTEST_PROG_RUN) $$params --aot=outfile=$$tmpfile $$assembly >> test-aot-$${name}.stdout 2>> test-aot-$${name}.stderr;        \
1022                         then \
1023                                 passed=`expr $${passed} + 1`; \
1024                         else \
1025                                 failed=`expr $${failed} + 1`; \
1026                                 failed_tests="$${failed_tests} $$test_name"; \
1027                         fi \
1028                 done;   \
1029         done;   \
1030         rm      $$tmpfile;      \
1031         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1032         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1033         for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1034
1035
1036 # Generated tests for runtime invoke
1037 EXTRA_DIST += gen-runtime-invoke.cs
1038 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
1039         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
1040         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
1041
1042 EXTRA_DIST += make-imt-test.cs
1043 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
1044         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
1045         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
1046
1047 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
1048 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
1049         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
1050 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
1051         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
1052
1053 EXTRA_DIST += unhandled-exception-base-configuration.config
1054 EXTRA_DIST += unhandled-exception-legacy-configuration.config
1055 EXTRA_DIST += appdomain-unload.exe.config
1056 EXTRA_DIST += unhandled-exception-test-case.2.cs
1057 EXTRA_DIST += unhandled-exception-test-runner.2.cs
1058 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
1059         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
1060 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
1061         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
1062 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
1063         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
1064 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
1065         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
1066         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
1067         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
1068         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
1069 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
1070         $(MCS) /debug unhandled-exception-test-case.1.cs
1071 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
1072         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
1073 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
1074         $(MCS) /debug unhandled-exception-test-case.2.cs
1075 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1076         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1077 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1078         $(MCS) /debug unhandled-exception-test-runner.2.cs
1079
1080 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1081         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1082
1083 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1084 bug-80307.exe: $(srcdir)/bug-80307.cs
1085         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1086         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1087
1088 EXTRA_DIST += bug-81673-interface.cs
1089 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1090         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1091         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1092         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1093
1094 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1095 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1096         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1097         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1098         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1099         rm -f bug-81691-a.dll
1100 bug-81691.exe: bug-81691-b.dll
1101
1102 EXTRA_DIST += bug-81466-lib.il
1103 bug-81466-lib.dll: bug-81466-lib.il
1104         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1105 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1106         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1107
1108 EXTRA_DIST += bug-324535-il.il
1109 bug-324535-il.dll : bug-324535-il.il
1110         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1111 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1112         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1113
1114 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1115 custom-modifiers-lib.dll: custom-modifiers-lib.il
1116         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1117 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1118         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1119
1120 EXTRA_DIST += bug-382986-lib.cs
1121 bug-382986-lib.dll: bug-382986-lib.cs
1122         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1123 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1124         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1125
1126 EXTRA_DIST += coreclr-security.cs
1127
1128 coreclr-security.exe : coreclr-security.cs
1129         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1130
1131 test-coreclr-security : coreclr-security.exe
1132         @echo "Testing coreclr-security.exe..."
1133         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1134
1135 EXTRA_DIST += generic-unboxing.2.il
1136 generic-unboxing.2.dll : generic-unboxing.2.il
1137         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1138
1139 EXTRA_DIST += generic-boxing.2.il
1140 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1141         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1142
1143 EXTRA_DIST += generic-unbox.2.cs
1144 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1145         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1146
1147 EXTRA_DIST += generic-box.2.cs
1148 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1149         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1150
1151 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1152 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1153         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1154 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1155         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1156
1157 bug-3903.exe: bug-3903.cs
1158         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1159
1160 gshared: test-generic-sharing
1161
1162 gshared-aot:
1163         @$(MAKE) AOT=1 gshared
1164
1165 GSHARED_TESTS = \
1166                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1167                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1168                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1169                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1170                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1171                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1172                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1173                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1174                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1175                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1176                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1177                 generic-array-exc.2.exe generic-special.2.exe                   \
1178                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1179                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1180                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1181                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1182                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1183                 generic-constrained.2.exe bug-431413.2.exe                      \
1184                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1185                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1186                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1187                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1188                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1189                 bug-479763.2.exe generic-xdomain.2.exe                          \
1190                 generic-type-load-exception.2.exe bug-616463.exe        \
1191                 bug-1147.exe
1192
1193 test-generic-sharing-normal: $(GSHARED_TESTS)
1194         @for fn in $+ ; do      \
1195                 echo "Testing $$fn ...";        \
1196                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
1197                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
1198                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
1199                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
1200                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1201         done
1202
1203 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1204         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1205
1206 if NACL_CODEGEN
1207 test-generic-sharing:
1208 else
1209 test-generic-sharing:
1210         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1211 endif
1212
1213 EXTRA_DIST += async-exceptions.cs
1214 async-exceptions.exe : async-exceptions.cs
1215         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1216 test-async-exceptions : async-exceptions.exe
1217         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1218         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1219
1220 EXTRA_DIST += modules.cs modules-m1.cs
1221 modules-m1.netmodule: modules-m1.cs
1222         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1223 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1224         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1225
1226 # Useful if mono is compiled with --enable-shared=no
1227 patch-libtool:
1228         cp "../../libtool" .
1229         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1230         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1231         touch libtest.c
1232
1233
1234 if NACL_CODEGEN
1235 test-process-exit:
1236 else
1237 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1238 test-process-exit:
1239         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1240         @echo "Testing bug-438454.exe..."
1241         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1242         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1243         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1244         @echo "Testing threadpool-in-processexit.exe..."
1245         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1246         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1247 endif
1248
1249 OOM_TESTS =     \
1250         gc-oom-handling.exe     \
1251         gc-oom-handling2.exe
1252
1253
1254 test-oom: $(OOM_TESTS)
1255         @for fn in $+ ; do      \
1256                 echo "Testing $$fn ...";        \
1257                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1258                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1259                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1260         done
1261
1262
1263 noinst_LTLIBRARIES = libtest.la
1264
1265 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1266
1267 if HOST_WIN32
1268 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1269 # This shows up when compiling mono_test_marshal_delegate ()
1270 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1271 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1272 # can't find them. So we use --kill-at to remove the @ suffix as well.
1273 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1274 else
1275 libtest_la_LDFLAGS = -rpath `pwd`
1276 endif
1277 libtest_la_SOURCES = libtest.c
1278 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1279
1280 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat